"use strict";
function _array_like_to_array(arr, len) {
    if (len == null || len > arr.length) len = arr.length;
    for(var i = 0, arr2 = new Array(len); i < len; i++)arr2[i] = arr[i];
    return arr2;
}
function _array_with_holes(arr) {
    if (Array.isArray(arr)) return arr;
}
function _array_without_holes(arr) {
    if (Array.isArray(arr)) return _array_like_to_array(arr);
}
function _assert_this_initialized(self) {
    if (self === void 0) {
        throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    }
    return self;
}
function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) {
    try {
        var info = gen[key](arg);
        var value = info.value;
    } catch (error) {
        reject(error);
        return;
    }
    if (info.done) {
        resolve(value);
    } else {
        Promise.resolve(value).then(_next, _throw);
    }
}
function _async_to_generator(fn) {
    return function() {
        var self = this, args = arguments;
        return new Promise(function(resolve, reject) {
            var gen = fn.apply(self, args);
            function _next(value) {
                asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value);
            }
            function _throw(err) {
                asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err);
            }
            _next(undefined);
        });
    };
}
function _class_call_check(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function");
    }
}
function _defineProperties(target, props) {
    for(var i = 0; i < props.length; i++){
        var descriptor = props[i];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor) descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
    }
}
function _create_class(Constructor, protoProps, staticProps) {
    if (protoProps) _defineProperties(Constructor.prototype, protoProps);
    if (staticProps) _defineProperties(Constructor, staticProps);
    return Constructor;
}
function _define_property(obj, key, value) {
    if (key in obj) {
        Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
        });
    } else {
        obj[key] = value;
    }
    return obj;
}
function _get_prototype_of(o) {
    _get_prototype_of = Object.setPrototypeOf ? Object.getPrototypeOf : function getPrototypeOf(o) {
        return o.__proto__ || Object.getPrototypeOf(o);
    };
    return _get_prototype_of(o);
}
function _inherits(subClass, superClass) {
    if (typeof superClass !== "function" && superClass !== null) {
        throw new TypeError("Super expression must either be null or a function");
    }
    subClass.prototype = Object.create(superClass && superClass.prototype, {
        constructor: {
            value: subClass,
            writable: true,
            configurable: true
        }
    });
    if (superClass) _set_prototype_of(subClass, superClass);
}
function _instanceof(left, right) {
    if (right != null && typeof Symbol !== "undefined" && right[Symbol.hasInstance]) {
        return !!right[Symbol.hasInstance](left);
    } else {
        return left instanceof right;
    }
}
function _iterable_to_array(iter) {
    if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter);
}
function _iterable_to_array_limit(arr, i) {
    var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"];
    if (_i == null) return;
    var _arr = [];
    var _n = true;
    var _d = false;
    var _s, _e;
    try {
        for(_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true){
            _arr.push(_s.value);
            if (i && _arr.length === i) break;
        }
    } catch (err) {
        _d = true;
        _e = err;
    } finally{
        try {
            if (!_n && _i["return"] != null) _i["return"]();
        } finally{
            if (_d) throw _e;
        }
    }
    return _arr;
}
function _non_iterable_rest() {
    throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}
function _non_iterable_spread() {
    throw new TypeError("Invalid attempt to spread non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}
function _object_spread(target) {
    for(var i = 1; i < arguments.length; i++){
        var source = arguments[i] != null ? arguments[i] : {};
        var ownKeys = Object.keys(source);
        if (typeof Object.getOwnPropertySymbols === "function") {
            ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function(sym) {
                return Object.getOwnPropertyDescriptor(source, sym).enumerable;
            }));
        }
        ownKeys.forEach(function(key) {
            _define_property(target, key, source[key]);
        });
    }
    return target;
}
function _possible_constructor_return(self, call) {
    if (call && (_type_of(call) === "object" || typeof call === "function")) {
        return call;
    }
    return _assert_this_initialized(self);
}
function _set_prototype_of(o, p) {
    _set_prototype_of = Object.setPrototypeOf || function setPrototypeOf(o, p) {
        o.__proto__ = p;
        return o;
    };
    return _set_prototype_of(o, p);
}
function _sliced_to_array(arr, i) {
    return _array_with_holes(arr) || _iterable_to_array_limit(arr, i) || _unsupported_iterable_to_array(arr, i) || _non_iterable_rest();
}
function _to_consumable_array(arr) {
    return _array_without_holes(arr) || _iterable_to_array(arr) || _unsupported_iterable_to_array(arr) || _non_iterable_spread();
}
function _type_of(obj) {
    "@swc/helpers - typeof";
    return obj && typeof Symbol !== "undefined" && obj.constructor === Symbol ? "symbol" : typeof obj;
}
function _unsupported_iterable_to_array(o, minLen) {
    if (!o) return;
    if (typeof o === "string") return _array_like_to_array(o, minLen);
    var n = Object.prototype.toString.call(o).slice(8, -1);
    if (n === "Object" && o.constructor) n = o.constructor.name;
    if (n === "Map" || n === "Set") return Array.from(n);
    if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _array_like_to_array(o, minLen);
}
function _is_native_reflect_construct() {
    if (typeof Reflect === "undefined" || !Reflect.construct) return false;
    if (Reflect.construct.sham) return false;
    if (typeof Proxy === "function") return true;
    try {
        Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {}));
        return true;
    } catch (e) {
        return false;
    }
}
function _create_super(Derived) {
    var hasNativeReflectConstruct = _is_native_reflect_construct();
    return function _createSuperInternal() {
        var Super = _get_prototype_of(Derived), result;
        if (hasNativeReflectConstruct) {
            var NewTarget = _get_prototype_of(this).constructor;
            result = Reflect.construct(Super, arguments, NewTarget);
        } else {
            result = Super.apply(this, arguments);
        }
        return _possible_constructor_return(this, result);
    };
}
function _ts_generator(thisArg, body) {
    var f, y, t, g, _ = {
        label: 0,
        sent: function() {
            if (t[0] & 1) throw t[1];
            return t[1];
        },
        trys: [],
        ops: []
    };
    return g = {
        next: verb(0),
        "throw": verb(1),
        "return": verb(2)
    }, typeof Symbol === "function" && (g[Symbol.iterator] = function() {
        return this;
    }), g;
    function verb(n) {
        return function(v) {
            return step([
                n,
                v
            ]);
        };
    }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while(_)try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [
                op[0] & 2,
                t.value
            ];
            switch(op[0]){
                case 0:
                case 1:
                    t = op;
                    break;
                case 4:
                    _.label++;
                    return {
                        value: op[1],
                        done: false
                    };
                case 5:
                    _.label++;
                    y = op[1];
                    op = [
                        0
                    ];
                    continue;
                case 7:
                    op = _.ops.pop();
                    _.trys.pop();
                    continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                        _ = 0;
                        continue;
                    }
                    if (op[0] === 3 && (!t || op[1] > t[0] && op[1] < t[3])) {
                        _.label = op[1];
                        break;
                    }
                    if (op[0] === 6 && _.label < t[1]) {
                        _.label = t[1];
                        t = op;
                        break;
                    }
                    if (t && _.label < t[2]) {
                        _.label = t[2];
                        _.ops.push(op);
                        break;
                    }
                    if (t[2]) _.ops.pop();
                    _.trys.pop();
                    continue;
            }
            op = body.call(thisArg, _);
        } catch (e) {
            op = [
                6,
                e
            ];
            y = 0;
        } finally{
            f = t = 0;
        }
        if (op[0] & 5) throw op[1];
        return {
            value: op[0] ? op[1] : void 0,
            done: true
        };
    }
}
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __defNormalProp = function(obj, key, value) {
    return key in obj ? __defProp(obj, key, {
        enumerable: true,
        configurable: true,
        writable: true,
        value: value
    }) : obj[key] = value;
};
var __export = function(target, all) {
    for(var name in all)__defProp(target, name, {
        get: all[name],
        enumerable: true
    });
};
var __copyProps = function(to, from, except, desc) {
    if (from && typeof from === "object" || typeof from === "function") {
        var _iteratorNormalCompletion = true, _didIteratorError = false, _iteratorError = undefined;
        try {
            var _loop = function() {
                var key = _step.value;
                if (!__hasOwnProp.call(to, key) && key !== except) __defProp(to, key, {
                    get: function() {
                        return from[key];
                    },
                    enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable
                });
            };
            for(var _iterator = __getOwnPropNames(from)[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true)_loop();
        } catch (err) {
            _didIteratorError = true;
            _iteratorError = err;
        } finally{
            try {
                if (!_iteratorNormalCompletion && _iterator.return != null) {
                    _iterator.return();
                }
            } finally{
                if (_didIteratorError) {
                    throw _iteratorError;
                }
            }
        }
    }
    return to;
};
var __toESM = function(mod, isNodeMode, target) {
    return target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(// If the importer is in node compatibility mode or this is not an ESM
    // file that has been converted to a CommonJS file using a Babel-
    // compatible transform (i.e. "__esModule" has not been set), then set
    // "default" to the CommonJS "module.exports" for node compatibility.
    isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", {
        value: mod,
        enumerable: true
    }) : target, mod);
};
var __toCommonJS = function(mod) {
    return __copyProps(__defProp({}, "__esModule", {
        value: true
    }), mod);
};
var __publicField = function(obj, key, value) {
    __defNormalProp(obj, (typeof key === "undefined" ? "undefined" : _type_of(key)) !== "symbol" ? key + "" : key, value);
    return value;
};
// src/index.tsx
var src_exports = {};
__export(src_exports, {
    cacheStore: function() {
        return cacheStore;
    },
    default: function() {
        return InlineSVG;
    }
});
module.exports = __toCommonJS(src_exports);
var React = __toESM(require("react"));
var import_react_from_dom = __toESM(require("react-from-dom"));
// src/config.ts
var CACHE_NAME = "react-inlinesvg";
var CACHE_MAX_RETRIES = 10;
var STATUS = {
    IDLE: "idle",
    LOADING: "loading",
    LOADED: "loaded",
    FAILED: "failed",
    READY: "ready",
    UNSUPPORTED: "unsupported"
};
// src/helpers.ts
var import_exenv = require("exenv");
function canUseDOM() {
    return import_exenv.canUseDOM;
}
function isSupportedEnvironment() {
    return supportsInlineSVG() && typeof window !== "undefined" && window !== null;
}
function request(url, options) {
    return _request.apply(this, arguments);
}
function _request() {
    _request = _async_to_generator(function(url, options) {
        var response, contentType, _split, fileType;
        return _ts_generator(this, function(_state) {
            switch(_state.label){
                case 0:
                    return [
                        4,
                        fetch(url, options)
                    ];
                case 1:
                    response = _state.sent();
                    contentType = response.headers.get("content-type");
                    _split = _sliced_to_array((contentType || "").split(/ ?; ?/), 1), fileType = _split[0];
                    if (response.status > 299) {
                        throw new Error("Not found");
                    }
                    if (![
                        "image/svg+xml",
                        "text/plain"
                    ].some(function(d) {
                        return fileType.includes(d);
                    })) {
                        throw new Error("Content type isn't valid: ".concat(fileType));
                    }
                    return [
                        2,
                        response.text()
                    ];
            }
        });
    });
    return _request.apply(this, arguments);
}
function sleep() {
    var seconds = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : 1;
    return new Promise(function(resolve) {
        setTimeout(resolve, seconds * 1e3);
    });
}
function supportsInlineSVG() {
    if (!document) {
        return false;
    }
    var div = document.createElement("div");
    div.innerHTML = "<svg />";
    var svg = div.firstChild;
    return !!svg && svg.namespaceURI === "http://www.w3.org/2000/svg";
}
function randomCharacter(character) {
    return character[Math.floor(Math.random() * character.length)];
}
function randomString(length) {
    var letters = "abcdefghijklmnopqrstuvwxyz";
    var numbers = "1234567890";
    var charset = "".concat(letters).concat(letters.toUpperCase()).concat(numbers);
    var R = "";
    for(var index = 0; index < length; index++){
        R += randomCharacter(charset);
    }
    return R;
}
function omit(input) {
    for(var _len = arguments.length, filter = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++){
        filter[_key - 1] = arguments[_key];
    }
    var output = {};
    for(var key in input){
        if (({}).hasOwnProperty.call(input, key)) {
            if (!filter.includes(key)) {
                output[key] = input[key];
            }
        }
    }
    return output;
}
// src/cache.ts
var CacheStore = /*#__PURE__*/ function() {
    function CacheStore() {
        var _this = this;
        _class_call_check(this, CacheStore);
        __publicField(this, "cacheApi");
        __publicField(this, "cacheStore");
        __publicField(this, "subscribers", []);
        __publicField(this, "usePersistentCache");
        __publicField(this, "isReady", false);
        this.cacheStore = /* @__PURE__ */ new Map();
        this.usePersistentCache = "REACT_INLINESVG_PERSISTENT_CACHE" in window && !!window.REACT_INLINESVG_PERSISTENT_CACHE;
        if (this.usePersistentCache) {
            caches.open(CACHE_NAME).then(function(cache) {
                _this.cacheApi = cache;
                _this.isReady = true;
                _this.subscribers.forEach(function(callback) {
                    return callback();
                });
            });
        } else {
            this.isReady = true;
        }
    }
    _create_class(CacheStore, [
        {
            key: "onReady",
            value: function onReady(callback) {
                if (this.isReady) {
                    callback();
                } else {
                    this.subscribers.push(callback);
                }
            }
        },
        {
            key: "get",
            value: function get(url, fetchOptions) {
                var _this = this;
                return _async_to_generator(function() {
                    var _this_cacheStore_get, _this_cacheStore_get_content;
                    return _ts_generator(this, function(_state) {
                        switch(_state.label){
                            case 0:
                                return [
                                    4,
                                    _this.usePersistentCache ? _this.fetchAndAddToPersistentCache(url, fetchOptions) : _this.fetchAndAddToInternalCache(url, fetchOptions)
                                ];
                            case 1:
                                _state.sent();
                                return [
                                    2,
                                    (_this_cacheStore_get_content = (_this_cacheStore_get = _this.cacheStore.get(url)) === null || _this_cacheStore_get === void 0 ? void 0 : _this_cacheStore_get.content) !== null && _this_cacheStore_get_content !== void 0 ? _this_cacheStore_get_content : ""
                                ];
                        }
                    });
                })();
            }
        },
        {
            key: "set",
            value: function set(url, data) {
                this.cacheStore.set(url, data);
            }
        },
        {
            key: "isCached",
            value: function isCached(url) {
                var _this_cacheStore_get;
                return ((_this_cacheStore_get = this.cacheStore.get(url)) === null || _this_cacheStore_get === void 0 ? void 0 : _this_cacheStore_get.status) === STATUS.LOADED;
            }
        },
        {
            key: "fetchAndAddToInternalCache",
            value: function fetchAndAddToInternalCache(url, fetchOptions) {
                var _this = this;
                return _async_to_generator(function() {
                    var _cache, _cache1, cache, content, error;
                    return _ts_generator(this, function(_state) {
                        switch(_state.label){
                            case 0:
                                cache = _this.cacheStore.get(url);
                                if (!(((_cache = cache) === null || _cache === void 0 ? void 0 : _cache.status) === STATUS.LOADING)) return [
                                    3,
                                    2
                                ];
                                return [
                                    4,
                                    _this.handleLoading(url, /*#__PURE__*/ _async_to_generator(function() {
                                        return _ts_generator(this, function(_state) {
                                            switch(_state.label){
                                                case 0:
                                                    _this.cacheStore.set(url, {
                                                        content: "",
                                                        status: STATUS.IDLE
                                                    });
                                                    return [
                                                        4,
                                                        _this.fetchAndAddToInternalCache(url, fetchOptions)
                                                    ];
                                                case 1:
                                                    _state.sent();
                                                    return [
                                                        2
                                                    ];
                                            }
                                        });
                                    }))
                                ];
                            case 1:
                                _state.sent();
                                return [
                                    2
                                ];
                            case 2:
                                if (!!((_cache1 = cache) === null || _cache1 === void 0 ? void 0 : _cache1.content)) return [
                                    3,
                                    6
                                ];
                                _this.cacheStore.set(url, {
                                    content: "",
                                    status: STATUS.LOADING
                                });
                                _state.label = 3;
                            case 3:
                                _state.trys.push([
                                    3,
                                    5,
                                    ,
                                    6
                                ]);
                                return [
                                    4,
                                    request(url, fetchOptions)
                                ];
                            case 4:
                                content = _state.sent();
                                _this.cacheStore.set(url, {
                                    content: content,
                                    status: STATUS.LOADED
                                });
                                return [
                                    3,
                                    6
                                ];
                            case 5:
                                error = _state.sent();
                                _this.cacheStore.set(url, {
                                    content: "",
                                    status: STATUS.FAILED
                                });
                                throw error;
                            case 6:
                                return [
                                    2
                                ];
                        }
                    });
                })();
            }
        },
        {
            key: "fetchAndAddToPersistentCache",
            value: function fetchAndAddToPersistentCache(url, fetchOptions) {
                var _this = this;
                return _async_to_generator(function() {
                    var _cache, _cache1, _this_cacheApi, cache, data, content, _this_cacheApi1, _this_cacheApi2, _response, response, _ref, content1, error;
                    return _ts_generator(this, function(_state) {
                        switch(_state.label){
                            case 0:
                                cache = _this.cacheStore.get(url);
                                if (((_cache = cache) === null || _cache === void 0 ? void 0 : _cache.status) === STATUS.LOADED) {
                                    return [
                                        2
                                    ];
                                }
                                if (!(((_cache1 = cache) === null || _cache1 === void 0 ? void 0 : _cache1.status) === STATUS.LOADING)) return [
                                    3,
                                    2
                                ];
                                return [
                                    4,
                                    _this.handleLoading(url, /*#__PURE__*/ _async_to_generator(function() {
                                        return _ts_generator(this, function(_state) {
                                            switch(_state.label){
                                                case 0:
                                                    _this.cacheStore.set(url, {
                                                        content: "",
                                                        status: STATUS.IDLE
                                                    });
                                                    return [
                                                        4,
                                                        _this.fetchAndAddToPersistentCache(url, fetchOptions)
                                                    ];
                                                case 1:
                                                    _state.sent();
                                                    return [
                                                        2
                                                    ];
                                            }
                                        });
                                    }))
                                ];
                            case 1:
                                _state.sent();
                                return [
                                    2
                                ];
                            case 2:
                                _this.cacheStore.set(url, {
                                    content: "",
                                    status: STATUS.LOADING
                                });
                                return [
                                    4,
                                    (_this_cacheApi = _this.cacheApi) === null || _this_cacheApi === void 0 ? void 0 : _this_cacheApi.match(url)
                                ];
                            case 3:
                                data = _state.sent();
                                if (!data) return [
                                    3,
                                    5
                                ];
                                return [
                                    4,
                                    data.text()
                                ];
                            case 4:
                                content = _state.sent();
                                _this.cacheStore.set(url, {
                                    content: content,
                                    status: STATUS.LOADED
                                });
                                return [
                                    2
                                ];
                            case 5:
                                _state.trys.push([
                                    5,
                                    9,
                                    ,
                                    10
                                ]);
                                return [
                                    4,
                                    (_this_cacheApi1 = _this.cacheApi) === null || _this_cacheApi1 === void 0 ? void 0 : _this_cacheApi1.add(new Request(url, fetchOptions))
                                ];
                            case 6:
                                _state.sent();
                                return [
                                    4,
                                    (_this_cacheApi2 = _this.cacheApi) === null || _this_cacheApi2 === void 0 ? void 0 : _this_cacheApi2.match(url)
                                ];
                            case 7:
                                response = _state.sent();
                                return [
                                    4,
                                    (_response = response) === null || _response === void 0 ? void 0 : _response.text()
                                ];
                            case 8:
                                content1 = (_ref = _state.sent()) !== null && _ref !== void 0 ? _ref : "";
                                _this.cacheStore.set(url, {
                                    content: content1,
                                    status: STATUS.LOADED
                                });
                                return [
                                    3,
                                    10
                                ];
                            case 9:
                                error = _state.sent();
                                _this.cacheStore.set(url, {
                                    content: "",
                                    status: STATUS.FAILED
                                });
                                throw error;
                            case 10:
                                return [
                                    2
                                ];
                        }
                    });
                })();
            }
        },
        {
            key: "handleLoading",
            value: function handleLoading(url, callback) {
                var _this = this;
                return _async_to_generator(function() {
                    var _this_cacheStore_get, retryCount;
                    return _ts_generator(this, function(_state) {
                        switch(_state.label){
                            case 0:
                                retryCount = 0;
                                _state.label = 1;
                            case 1:
                                if (!(((_this_cacheStore_get = _this.cacheStore.get(url)) === null || _this_cacheStore_get === void 0 ? void 0 : _this_cacheStore_get.status) === STATUS.LOADING && retryCount < CACHE_MAX_RETRIES)) return [
                                    3,
                                    3
                                ];
                                return [
                                    4,
                                    sleep(0.1)
                                ];
                            case 2:
                                _state.sent();
                                retryCount += 1;
                                return [
                                    3,
                                    1
                                ];
                            case 3:
                                if (!(retryCount >= CACHE_MAX_RETRIES)) return [
                                    3,
                                    5
                                ];
                                return [
                                    4,
                                    callback()
                                ];
                            case 4:
                                _state.sent();
                                _state.label = 5;
                            case 5:
                                return [
                                    2
                                ];
                        }
                    });
                })();
            }
        },
        {
            key: "keys",
            value: function keys() {
                return _to_consumable_array(this.cacheStore.keys());
            }
        },
        {
            key: "data",
            value: function data() {
                return _to_consumable_array(this.cacheStore.entries()).map(function(param) {
                    var _param = _sliced_to_array(param, 2), key = _param[0], value = _param[1];
                    return _define_property({}, key, value);
                });
            }
        },
        {
            key: "delete",
            value: function _delete(url) {
                var _this = this;
                return _async_to_generator(function() {
                    return _ts_generator(this, function(_state) {
                        switch(_state.label){
                            case 0:
                                if (!_this.cacheApi) return [
                                    3,
                                    2
                                ];
                                return [
                                    4,
                                    _this.cacheApi.delete(url)
                                ];
                            case 1:
                                _state.sent();
                                _state.label = 2;
                            case 2:
                                _this.cacheStore.delete(url);
                                return [
                                    2
                                ];
                        }
                    });
                })();
            }
        },
        {
            key: "clear",
            value: function clear() {
                var _this = this;
                return _async_to_generator(function() {
                    var keys, _iteratorNormalCompletion, _didIteratorError, _iteratorError, _iterator, _step, key, err;
                    return _ts_generator(this, function(_state) {
                        switch(_state.label){
                            case 0:
                                if (!_this.cacheApi) return [
                                    3,
                                    9
                                ];
                                return [
                                    4,
                                    _this.cacheApi.keys()
                                ];
                            case 1:
                                keys = _state.sent();
                                _iteratorNormalCompletion = true, _didIteratorError = false, _iteratorError = undefined;
                                _state.label = 2;
                            case 2:
                                _state.trys.push([
                                    2,
                                    7,
                                    8,
                                    9
                                ]);
                                _iterator = keys[Symbol.iterator]();
                                _state.label = 3;
                            case 3:
                                if (!!(_iteratorNormalCompletion = (_step = _iterator.next()).done)) return [
                                    3,
                                    6
                                ];
                                key = _step.value;
                                return [
                                    4,
                                    _this.cacheApi.delete(key)
                                ];
                            case 4:
                                _state.sent();
                                _state.label = 5;
                            case 5:
                                _iteratorNormalCompletion = true;
                                return [
                                    3,
                                    3
                                ];
                            case 6:
                                return [
                                    3,
                                    9
                                ];
                            case 7:
                                err = _state.sent();
                                _didIteratorError = true;
                                _iteratorError = err;
                                return [
                                    3,
                                    9
                                ];
                            case 8:
                                try {
                                    if (!_iteratorNormalCompletion && _iterator.return != null) {
                                        _iterator.return();
                                    }
                                } finally{
                                    if (_didIteratorError) {
                                        throw _iteratorError;
                                    }
                                }
                                return [
                                    7
                                ];
                            case 9:
                                _this.cacheStore.clear();
                                return [
                                    2
                                ];
                        }
                    });
                })();
            }
        }
    ]);
    return CacheStore;
}();
// src/index.tsx
var import_jsx_runtime = require("react/jsx-runtime");
var cacheStore;
var ReactInlineSVG = /*#__PURE__*/ function(_React_PureComponent) {
    _inherits(ReactInlineSVG, _React_PureComponent);
    var _super = _create_super(ReactInlineSVG);
    function ReactInlineSVG(props) {
        _class_call_check(this, ReactInlineSVG);
        var _this;
        _this = _super.call(this, props);
        __publicField(_assert_this_initialized(_this), "hash");
        __publicField(_assert_this_initialized(_this), "isActive", false);
        __publicField(_assert_this_initialized(_this), "isInitialized", false);
        var _this1 = _assert_this_initialized(_this);
        __publicField(_assert_this_initialized(_this), "fetchContent", /*#__PURE__*/ _async_to_generator(function() {
            var _this_props, fetchOptions, src, content;
            return _ts_generator(this, function(_state) {
                switch(_state.label){
                    case 0:
                        _this_props = _this1.props, fetchOptions = _this_props.fetchOptions, src = _this_props.src;
                        return [
                            4,
                            request(src, fetchOptions)
                        ];
                    case 1:
                        content = _state.sent();
                        _this1.handleLoad(content);
                        return [
                            2
                        ];
                }
            });
        }));
        __publicField(_assert_this_initialized(_this), "handleError", function(error) {
            var onError = _this.props.onError;
            var status = error.message === "Browser does not support SVG" ? STATUS.UNSUPPORTED : STATUS.FAILED;
            if (_this.isActive) {
                _this.setState({
                    status: status
                }, function() {
                    if (typeof onError === "function") {
                        onError(error);
                    }
                });
            }
        });
        __publicField(_assert_this_initialized(_this), "handleLoad", function(content) {
            var hasCache = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : false;
            if (_this.isActive) {
                _this.setState({
                    content: content,
                    isCached: hasCache,
                    status: STATUS.LOADED
                }, _this.getElement);
            }
        });
        _this.state = {
            content: "",
            element: null,
            isCached: !!props.cacheRequests && cacheStore.isCached(props.src),
            status: STATUS.IDLE
        };
        _this.hash = props.uniqueHash || randomString(8);
        return _this;
    }
    _create_class(ReactInlineSVG, [
        {
            key: "componentDidMount",
            value: function componentDidMount() {
                this.isActive = true;
                if (!canUseDOM() || this.isInitialized) {
                    return;
                }
                var status = this.state.status;
                var src = this.props.src;
                try {
                    if (status === STATUS.IDLE) {
                        if (!isSupportedEnvironment()) {
                            throw new Error("Browser does not support SVG");
                        }
                        if (!src) {
                            throw new Error("Missing src");
                        }
                        this.load();
                    }
                } catch (error) {
                    this.handleError(error);
                }
                this.isInitialized = true;
            }
        },
        {
            key: "componentDidUpdate",
            value: function componentDidUpdate(previousProps, previousState) {
                if (!canUseDOM()) {
                    return;
                }
                var _this_state = this.state, isCached = _this_state.isCached, status = _this_state.status;
                var _this_props = this.props, onLoad = _this_props.onLoad, src = _this_props.src;
                if (previousState.status !== STATUS.READY && status === STATUS.READY) {
                    if (onLoad) {
                        onLoad(src, isCached);
                    }
                }
                if (previousProps.src !== src) {
                    if (!src) {
                        this.handleError(new Error("Missing src"));
                        return;
                    }
                    this.load();
                }
            }
        },
        {
            key: "componentWillUnmount",
            value: function componentWillUnmount() {
                this.isActive = false;
            }
        },
        {
            key: "getElement",
            value: function getElement() {
                try {
                    var node = this.getNode();
                    var element = (0, import_react_from_dom.default)(node);
                    if (!element || !React.isValidElement(element)) {
                        throw new Error("Could not convert the src to a React element");
                    }
                    this.setState({
                        element: element,
                        status: STATUS.READY
                    });
                } catch (error) {
                    this.handleError(new Error(error.message));
                }
            }
        },
        {
            key: "getNode",
            value: function getNode() {
                var _this_props = this.props, description = _this_props.description, title = _this_props.title;
                try {
                    var svgText = this.processSVG();
                    var node = (0, import_react_from_dom.default)(svgText, {
                        nodeOnly: true
                    });
                    if (!node || !_instanceof(node, SVGSVGElement)) {
                        throw new Error("Could not convert the src to a DOM Node");
                    }
                    var svg = this.updateSVGAttributes(node);
                    if (description) {
                        var originalDesc = svg.querySelector("desc");
                        if (originalDesc && originalDesc.parentNode) {
                            originalDesc.parentNode.removeChild(originalDesc);
                        }
                        var descElement = document.createElementNS("http://www.w3.org/2000/svg", "desc");
                        descElement.innerHTML = description;
                        svg.prepend(descElement);
                    }
                    if (typeof title !== "undefined") {
                        var originalTitle = svg.querySelector("title");
                        if (originalTitle && originalTitle.parentNode) {
                            originalTitle.parentNode.removeChild(originalTitle);
                        }
                        if (title) {
                            var titleElement = document.createElementNS("http://www.w3.org/2000/svg", "title");
                            titleElement.innerHTML = title;
                            svg.prepend(titleElement);
                        }
                    }
                    return svg;
                } catch (error) {
                    return this.handleError(error);
                }
            }
        },
        {
            key: "load",
            value: function load() {
                if (this.isActive) {
                    var _this = this;
                    this.setState({
                        content: "",
                        element: null,
                        isCached: false,
                        status: STATUS.LOADING
                    }, /*#__PURE__*/ _async_to_generator(function() {
                        var _this_props, cacheRequests, fetchOptions, src, dataURI, inlineSrc, content, error;
                        return _ts_generator(this, function(_state) {
                            switch(_state.label){
                                case 0:
                                    _this_props = _this.props, cacheRequests = _this_props.cacheRequests, fetchOptions = _this_props.fetchOptions, src = _this_props.src;
                                    dataURI = src.match(RegExp("^data:image\\/svg[^,]*?(;base64)?,(.*)", "u"));
                                    if (dataURI) {
                                        inlineSrc = dataURI[1] ? window.atob(dataURI[2]) : decodeURIComponent(dataURI[2]);
                                    } else if (src.includes("<svg")) {
                                        inlineSrc = src;
                                    }
                                    if (inlineSrc) {
                                        _this.handleLoad(inlineSrc);
                                        return [
                                            2
                                        ];
                                    }
                                    _state.label = 1;
                                case 1:
                                    _state.trys.push([
                                        1,
                                        6,
                                        ,
                                        7
                                    ]);
                                    if (!cacheRequests) return [
                                        3,
                                        3
                                    ];
                                    return [
                                        4,
                                        cacheStore.get(src, fetchOptions)
                                    ];
                                case 2:
                                    content = _state.sent();
                                    _this.handleLoad(content, true);
                                    return [
                                        3,
                                        5
                                    ];
                                case 3:
                                    return [
                                        4,
                                        _this.fetchContent()
                                    ];
                                case 4:
                                    _state.sent();
                                    _state.label = 5;
                                case 5:
                                    return [
                                        3,
                                        7
                                    ];
                                case 6:
                                    error = _state.sent();
                                    _this.handleError(error);
                                    return [
                                        3,
                                        7
                                    ];
                                case 7:
                                    return [
                                        2
                                    ];
                            }
                        });
                    }));
                }
            }
        },
        {
            key: "processSVG",
            value: function processSVG() {
                var content = this.state.content;
                var preProcessor = this.props.preProcessor;
                if (preProcessor) {
                    return preProcessor(content);
                }
                return content;
            }
        },
        {
            key: "updateSVGAttributes",
            value: function updateSVGAttributes(node) {
                var _this = this;
                var _this_props = this.props, _this_props_baseURL = _this_props.baseURL, baseURL = _this_props_baseURL === void 0 ? "" : _this_props_baseURL, uniquifyIDs = _this_props.uniquifyIDs;
                var replaceableAttributes = [
                    "id",
                    "href",
                    "xlink:href",
                    "xlink:role",
                    "xlink:arcrole"
                ];
                var linkAttributes = [
                    "href",
                    "xlink:href"
                ];
                var isDataValue = function(name, value) {
                    return linkAttributes.includes(name) && (value ? !value.includes("#") : false);
                };
                if (!uniquifyIDs) {
                    return node;
                }
                _to_consumable_array(node.children).forEach(function(d) {
                    if (d.attributes && d.attributes.length) {
                        var attributes = Object.values(d.attributes).map(function(a) {
                            var attribute = a;
                            var match = a.value.match(/url\((.*?)\)/);
                            if (match && match[1]) {
                                attribute.value = a.value.replace(match[0], "url(".concat(baseURL).concat(match[1], "__").concat(_this.hash, ")"));
                            }
                            return attribute;
                        });
                        replaceableAttributes.forEach(function(r) {
                            var attribute = attributes.find(function(a) {
                                return a.name === r;
                            });
                            if (attribute && !isDataValue(r, attribute.value)) {
                                attribute.value = "".concat(attribute.value, "__").concat(_this.hash);
                            }
                        });
                    }
                    if (d.children.length) {
                        return _this.updateSVGAttributes(d);
                    }
                    return d;
                });
                return node;
            }
        },
        {
            key: "render",
            value: function render() {
                var _this_state = this.state, element = _this_state.element, status = _this_state.status;
                var _this_props = this.props, _this_props_children = _this_props.children, children = _this_props_children === void 0 ? null : _this_props_children, innerRef = _this_props.innerRef, _this_props_loader = _this_props.loader, loader = _this_props_loader === void 0 ? null : _this_props_loader;
                var elementProps = omit(this.props, "baseURL", "cacheRequests", "children", "description", "fetchOptions", "innerRef", "loader", "onError", "onLoad", "preProcessor", "src", "title", "uniqueHash", "uniquifyIDs");
                if (!canUseDOM()) {
                    return loader;
                }
                if (element) {
                    return React.cloneElement(element, _object_spread({
                        ref: innerRef
                    }, elementProps));
                }
                if ([
                    STATUS.UNSUPPORTED,
                    STATUS.FAILED
                ].includes(status)) {
                    return children;
                }
                return loader;
            }
        }
    ]);
    return ReactInlineSVG;
}(React.PureComponent);
__publicField(ReactInlineSVG, "defaultProps", {
    cacheRequests: true,
    uniquifyIDs: false
});
function InlineSVG(props) {
    if (!cacheStore) {
        cacheStore = new CacheStore();
    }
    var loader = props.loader;
    var hasCallback = React.useRef(false);
    var _React_useState = _sliced_to_array(React.useState(cacheStore.isReady), 2), isReady = _React_useState[0], setReady = _React_useState[1];
    React.useEffect(function() {
        if (!hasCallback.current) {
            cacheStore.onReady(function() {
                setReady(true);
            });
            hasCallback.current = true;
        }
    }, []);
    if (!isReady) {
        return loader;
    }
    return /* @__PURE__ */ (0, import_jsx_runtime.jsx)(ReactInlineSVG, _object_spread({}, props));
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
    cacheStore: cacheStore
});
//# sourceMappingURL=index.js.map